class=require 'class'
require'player'
require'zombie'
require'bullet'
function love.load()
    initGame()

    mainPlayer=Player(256,256)
    mobs={}
    bullets={}
      bloodSystems={}
end

function love.draw()
    love.graphics.draw(fb2,0,0)
    mainPlayer:draw()
    for i,v in ipairs(mobs) do
        v:draw()
    end
    for i,v in ipairs(bullets) do
        v:draw()
    end
    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(images.cursor,love.mouse.getX(),love.mouse.getY())
    for i,v in ipairs(bloodSystems) do
        love.graphics.draw(v,0,0)
    end
    if gameState=="waiting" then
        love.graphics.setColor(0,0,0,200)
        love.graphics.rectangle('fill',0,0,world.width,world.height)
    end
    love.graphics.setColor(255,255,255,255)
    love.graphics.print(gameMessage,5,5)

end

function love.update(dt)

    dt = math.min(dt, 0.07)
    if gameState=="waiting" then
        if timer>0 then
            timer=timer-dt
            gameMessage="Insert coin to continue... "..math.ceil(timer)
        else
            gameMessage="Score: 0"
            gameState="inGame"
        end
    elseif gameState=="inGame" then
        mainPlayer:update(dt)
        for i,v in ipairs(bullets) do
            v:update(dt)
        end
        for i,v in ipairs(mobs) do
            v:update(dt)
        end
        for i,v in ipairs(bloodSystems) do
            v:update(dt)
            if v:count()==0 then
                love.graphics.setCanvas(fb1)

                    local x,y = v:getPosition()
                    local size = math.random(5,8)
                    love.graphics.setColor(255,50,50,105)
                    love.graphics.circle("fill",x,y, size)


                    love.graphics.setPixelEffect(fade)
                    love.graphics.setCanvas(fb2)
                    love.graphics.draw(fb1,0,0)
                                       love.graphics.setPixelEffect()
                                          love.graphics.setCanvas()
            end
        end
        if math.random(1,100)<=levelDifficulty then
            local x,y
            if math.random(1,2)==2 then
                x=math.random(0,1)*world.width
                y=math.random(0,world.height)
            else
                x=math.random(0,world.width)
                y=math.random(0,1)*world.height
            end
            local temp=Zombie(x,y,0)
            if lookingForControl then
                temp.hasControl=true
                lookingForControl=false
                controlTimer=999
            end
        end
            controlTimer=controlTimer-dt
            if controlTimer<0 then
                lookingForControl=true
            end
    end
end

function initGame()
    world={}
    world.width=512
    world.height=512
    love.graphics.setMode(world.width,world.height,false, true, 0)
    love.graphics.setBackgroundColor(0,0,0)
    local imageData = love.image.newImageData(1,1)
    imageData:setPixel( 0,0,255,100,50,255)
    redBox=love.graphics.newImage( imageData )
        sounds={}
    sounds.gun=love.audio.newSource("gun.wav", "static")
    images={}
    images.zombie=love.graphics.newImage("zombie.png")
    images.cursor=love.graphics.newImage("cursor.png")
    levelDifficulty=1
    love.mouse.setVisible(false)
    lookingForControl=true
    controlTimer=0
    gameMessage="Insert coin to continue..."
    timer=3
    gameState="waiting"
    fb1=love.graphics.newCanvas()
     fb2=love.graphics.newCanvas()
end

function makeBlood(x,y,facing)
    local system = love.graphics.newParticleSystem(redBox,40)
    system:setPosition(x,y)
    system:setDirection(facing)
    system:setLifetime(0.1)
    system:setEmissionRate(60)
    system:setParticleLife(0.5)
    system:setSizes( 0.8,1.1,1.2)
    system:setSpeed( 100, 150  )
    system:setSpread(0.5)
    system:setRadialAcceleration(-150,-100)
    system:start()
    table.insert(bloodSystems,system)
end

function resetGame()
    mainPlayer=Player(256,256)
    mobs={}
    gameState="waiting"
    timer=8
    lookingForControl=true
end
function deleteObject(tab,obj)
    for i,v in ipairs(tab) do
        if v==obj then
            table.remove(tab,i)
            return
        end
    end
end
function mag(x,y)
    return math.sqrt(x*x+y*y)
end




fade = love.graphics.newPixelEffect [[

        const float blurSize = 1.0/256.0;


        vec4 effect(vec4 global_color, Image texture, vec2 texture_coords, vec2 pixel_coords)
        {

        vec4 sum = vec4(0.0);
        float fade = 0.01;

       sum += (texture2D(texture, vec2(texture_coords.x - 4.0*blurSize, texture_coords.y)) * 0.05)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x - 3.0*blurSize, texture_coords.y)) * 0.09)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x - 2.0*blurSize, texture_coords.y)) * 0.12)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x - blurSize, texture_coords.y)) * 0.15)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x, texture_coords.y)) * 0.181)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x + blurSize, texture_coords.y)) * 0.15)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x + 2.0*blurSize, texture_coords.y)) * 0.12)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x + 3.0*blurSize, texture_coords.y)) * 0.09)-fade;
       sum += (texture2D(texture, vec2(texture_coords.x + 4.0*blurSize, texture_coords.y)) * 0.05)-fade;
        sum.a = 1;

         return sum ;
        }
    ]]
