Player = class{function(self, x,y)
    self.health=100
    self.x = x
    self.y = y
    self.facing=0
    self.size=10
    self.orders={}
    self.timer=0
    self.speed=0
    self.gunOffset=mag(10,4)
    self.gunOffsetAngle=math.atan2(4,10)
    self.baseSpeed=70
    self.score=0
end}

function Player:draw()
    love.graphics.push()
    love.graphics.translate(self.x,self.y)
    love.graphics.rotate(self.facing)
    love.graphics.translate(-self.x,-self.y)
    love.graphics.setColor(200,100,100)
    love.graphics.rectangle('fill',self.x-4,self.y-6,8,12)
    love.graphics.setColor(20,20,20)
    love.graphics.rectangle('fill',self.x-3,self.y-3,6,6)
    love.graphics.setColor(120,120,120)
    love.graphics.rectangle('fill',self.x+4,self.y+3,6,2)


    love.graphics.pop()
    love.graphics.setColor(10,230,10)
    love.graphics.rectangle('fill',self.x-10,self.y-15,self.health/5,3)
end

function Player:shoot()
    love.audio.rewind()
    love.audio.play(sounds.gun)
    local b=Bullet(self.x+math.cos(self.facing+self.gunOffsetAngle)*self.gunOffset,self.y+math.sin(self.facing+self.gunOffsetAngle)*self.gunOffset,self.facing)
end

function Player:target()

end
function Player:update(dt)
    self.x=math.min(world.width,math.max(0,self.x+math.cos(self.facing)*self.speed*dt))
    self.y=math.min(world.height,math.max(0,self.y+math.sin(self.facing)*self.speed*dt))

    if #self.orders==0 then
        local minDistance=999
        for i,v in ipairs(mobs) do
            minDistance=math.min(v.distanceToPlayer,minDistance)
            print (minDistance)
        end
        if minDistance>100 then
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'shoot'})
            table.insert(self.orders,{'random',1})
            table.insert(self.orders,{'random',1})
            table.insert(self.orders,{'random',0.5})
        else
            local random=math.random(1,4)
            if  random==3 then
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',1})
                 table.insert(self.orders,{'flee',0.8})
                 table.insert(self.orders,{'flee',0.8})
            elseif random==2 then
                 table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',1.3})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',1.2})
                table.insert(self.orders,{'flee',1.2})
                elseif random==3 then
                 table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',0.4})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',0.4})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',1})
                table.insert(self.orders,{'flee',1.5})
            else
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',0.5})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',0.5})
                table.insert(self.orders,{'shoot'})
                table.insert(self.orders,{'flee',1})
                 table.insert(self.orders,{'flee',1})
                  table.insert(self.orders,{'flee',0.5})
            end
        end

    elseif self.timer<=0 then
        local order=table.remove(self.orders,1)
        if order[1]=='random' then
            local ang=math.atan2(256-self.y,256-self.x)
            self.facing=math.random(-90,90)/180*math.pi+ang
            self.speed=self.baseSpeed
            self.timer=order[2]+math.random(-5,3)/30

        elseif order[1]=='shoot' then
        self.speed=0
            local v=self:findClosestMob()
            if v then
                self.facing=math.atan2(v.y-self.y,v.x-self.x)+math.random(-5,3)/30
                self:shoot()
                self.timer=0.2
            end
        elseif order[1]=='flee' then
            self.speed=self.baseSpeed
            local v=self:findClosestMob()
            if v then

                self.facing=math.atan2(self.y-v.y,self.x-v.x)
                                if self.facing<0 then
                    self.facing=self.facing+math.pi*2
                elseif self.facing>math.pi*2 then
                    self.facing=self.facing-math.pi*2
                end
                    print (self.facing)
                local margin=world.width/6
                if self.x<margin then
                    if self.facing<=math.pi*3/2 and self.facing>math.pi then
                        self.facing=self.facing+math.pi/2
                    elseif self.facing<=math.pi and self.facing>=math.pi/2 then
                        self.facing=self.facing-math.pi/2
                    end
                elseif self.x>world.width-margin then
                    if self.facing<=math.pi/2 and self.facing>0 then
                        self.facing=self.facing+math.pi/2
                    elseif self.facing<=math.pi*2 and self.facing>=math.pi*3/2 then
                        self.facing=self.facing-math.pi/2
                    end
                end
                if self.y<margin then
                    if self.facing<=math.pi*2 and self.facing>math.pi*3/2 then
                        self.facing=self.facing+math.pi/2
                    elseif self.facing<=math.pi*3/2 and self.facing>=math.pi then
                        self.facing=self.facing-math.pi/2
                    end
                elseif self.y>world.height-margin then
                    if self.facing<=math.pi and self.facing>math.pi/2 then
                        self.facing=self.facing+math.pi/2
                    elseif self.facing<=math.pi/2 and self.facing>=0 then
                        self.facing=self.facing-math.pi/2
                    end
                end
                self.timer=order[2]+math.random(-6,3)/30
            end
        end
    end
    self.timer=self.timer-dt

end


function Player:hit(facing)
    makeBlood(self.x,self.y,facing)
    self.health=self.health-1
    if self.health<0 then
        resetGame()
    end
end

function Player:findClosestMob()
            local minDistance=9999
                for i,v in ipairs(mobs) do
                if v.alive then
                    minDistance=math.min(v.distanceToPlayer,minDistance)
                end
            end
            for i,v in ipairs(mobs) do
                if minDistance==v.distanceToPlayer then
                    return v
                end
            end
            return false
end
