Zombie = class{function(self, x,y,facing)
    self.health=100
    self.x = x
    self.y = y
    self.facing=facing
    self.size=12
    self.orders={}
    self.alive=true
    self.control=false
    self.distanceToPlayer=999
    self.fadeOut=255
    self.hasControl=false
    table.insert(mobs,self)
end}

function Zombie:draw()
    love.graphics.push()
    love.graphics.translate(self.x,self.y)
    love.graphics.rotate(self.facing)
    love.graphics.translate(-self.x,-self.y)
    if self.hasControl then
        love.graphics.setColor(255,200,255,self.fadeOut)
    else
        love.graphics.setColor(255,255,255,self.fadeOut)
    end
    love.graphics.draw(images.zombie,self.x-4,self.y-6)
   --[[ love.graphics.setColor(34,100,80)
    love.graphics.rectangle('fill',self.x-4,self.y-6,8,12)

    love.graphics.rectangle('fill',self.x+4,self.y+2,6,3)
    love.graphics.rectangle('fill',self.x+4,self.y-5,6,3)
            love.graphics.setColor(20,150,20)
    love.graphics.rectangle('fill',self.x-3,self.y-3,6,6)]]--
    love.graphics.pop()

end

function Zombie:update(dt)
    if self.alive then
        self.distanceToPlayer=math.floor(((mainPlayer.y-self.y)^2+(mainPlayer.x-self.x)^2)^0.5)
        if self.distanceToPlayer<self.size then
            mainPlayer:hit(self.facing)
        else
            local ang=0
            if self.hasControl then
                ang=math.atan2(love.mouse.getY()-self.y,love.mouse.getX()-self.x)
            else
                ang=math.atan2(mainPlayer.y-self.y,mainPlayer.x-self.x)
            end
            self.facing=ang
            self.x=self.x+math.cos(ang)*45*dt
            self.y=self.y+math.sin(ang)*45*dt
        end
    else
        self.fadeOut=self.fadeOut-2
        if self.fadeOut<0 then
            self:destroy()
        end
    end
end

function Zombie:hit(facing)
self.x=self.x+math.cos(facing)*3
self.y=self.y+math.sin(facing)*3
makeBlood(self.x,self.y,facing)
self.health=self.health-51
    if self.health<0 then
        self.alive=false
        self.distanceToPlayer=999
        mainPlayer.score=mainPlayer.score+10
        gameMessage="Score: "..mainPlayer.score
        if self.hasControl then
            controlTimer=8
        end
    end
end

function Zombie:destroy()
  deleteObject(mobs,self)
end
